#include <avr/io.h>

//#include "fundamental.h" 
#define true  1
#define false 0

// #include "carroty_lib/led.h" 
#define LED_1_ON 0b11100000
#define LED_2_ON 0b11010000
#define LED_3_ON 0b10110000
#define LED_4_ON 0b01110000
#define LED_FULL_OFF 0b11110000

// #include "carroty_lib/key.h" 
#define KEY_1 0b00111000
#define KEY_2 0b00110100
#define KEY_3 0b00101100
#define KEY_4 0b00011100

#define KEY_MASK 0x3C

// #include "carroty/delay.h" 
void delay_us(unsigned char time_us)	{ 
  register unsigned char i;
  for(i = 0; i < time_us; i++) {  //   4 cycle
    asm volatile("PUSH R0 "); 	  // + 2 cycle
    asm volatile("POP  R0 ");	  // + 2 cycle
    asm volatile("PUSH R0 ");	  // + 2 cycle
    asm volatile("POP  R0 ");	  // + 2 cycle
    asm volatile("PUSH R0 ");	  // + 2 cycle
    asm volatile("POP  R0 ");	  // + 2 cycle	
    // 16 cycle * 62.5 ns = 1000 ns = 1 us at 16.000MHz
  }
}
void delay_ms(unsigned int time_ms) {	  // time delay(ms)
  register unsigned int i;
  for(i = 0; i < time_ms; i++) {
    delay_us(250);
    delay_us(250);
    delay_us(250);
    delay_us(250);
  }
}

// Լ  
unsigned char key_input(void);
unsigned char key_flag= 0;

int main() {
  unsigned char key= 0;
//  unsigned char count= 0;
  DDRB=  0xF0;      // PORTB 7~4Ʈ  (LED  Ǿ)
  DDRE=  0xC3;      // PORTD 5~2Ʈ Է (SW  Ǿ)
  PORTB= 0xF0;

  while(1) {
    //key= (PIND & KEY_MASK); 
	key= key_input();
    switch(key) {
      case KEY_1 : // key1 pressed...
	    PORTB= LED_1_ON; 
		delay_ms(10);
		break; 
      case KEY_2 : // key2 pressed...
	    PORTB= LED_2_ON; 
		delay_ms(10);
		break; 
      case KEY_3 : // key3 pressed...
	    PORTB= LED_3_ON; 
		delay_ms(10);
		break; 
      case KEY_4 : // key4 pressed...
	    PORTB= LED_4_ON; 
		delay_ms(10);
		break; 
      default : PORTB= LED_FULL_OFF; break; 
	}
  }
}

unsigned char key_input(void) {
  unsigned char key;
  key= (PINE & KEY_MASK);
  if(key==0x3C) {
    if(key_flag==0) { return key; }
    else { 
      delay_ms(10); 
      key_flag= 0;
      return key;
    }
  }
  else {
    if(key_flag != 0) { return 0x3C; }
    else {
      key_flag= 1;
      delay_ms(10); // beep
      return key;
    }
  }
}
