#include <avr/io.h>
#include <avr/interrupt.h>

#include "global.h"
#include "delay.h"
#include "key.h"
#include "led.h"

/* Interrupt Service Routine */
ISR(SIG_INTERRUPT4) { PORTB=LED_1_ON; }
ISR(SIG_INTERRUPT5) { PORTB=LED_2_ON; }

int main() {

  DDRB=0xF0;
  PORTB=0x0F;
  EICRB=0x08;
  EIMSK=0x30;
  EIFR=0xFF;
  MCUCR=0x0A;
  //GICR=0xC0;
  sei();
  while(true) {
    PORTB=(LED_1_ON);
    delay_ms(250);
    PORTB=(LED_2_ON);
    delay_ms(250);
  }
  return 0;
}
