#include <avr/io.h>
#include <avr/interrupt.h>
#include "global.h"

#define FREQ_CPU           16000000
#define PRESCALER          64
#define PRESCALED_FREQ FREQ_CPU/PRESCALER
#define PRESCALED_PERIOD 1/PRESCALED_FREQ
#define TCNT0_MAX           0xFF
#define TARGET_TIME         1000

ISR(TIMER0_OVF_vect) {
  PORTB ^= 0xFF;
}

int main(void) {
  
  DDRB=0xF0;
  TCCR0= 0xF0;
  
  cbi(TCCR1B, WGM13);
  cbi(TCCR1B, WGM12);
  cbi(TCCR1A, WGM11);
  cbi(TCCR1A, WGM10);

  cbi(TCCR1A, COM1A1);
  cbi(TCCR1A, COM1A1);
  cbi(TCCR1A, COM1A0);
  cbi(TCCR1A, COM1B0);

  cbi(TCCR1B, CS12);
  cbi(TCCR1B, CS11);
  sbi(TCCR1B, CS10);


  sbi(TIMSK, TOIE1);

  sei();
  while(true);
  return 0;
}
