#include <avr/io.h>
#include <avr/interrupt.h>

#include "global.h"

#define FREQ_CPU           16000000
#define PRESCALER          64
#define PRESCALED_FREQ FREQ_CPU/PRESCALER
#define PRESCALED_PERIOD 1/PRESCALED_FREQ
#define TCNT0_MAX           0xFF
#define TARGET_TIME         1000

ISR(TIMER0_OVF_vect) {
  PORTB ^= 0xFF;
}

int main(void) {
  
  DDRB=0xF0;
  PORTB= 0xF0;
  
  cbi(TCCR0, WGM00);
  cbi(TCCR0, WGM01);


  cbi(TCCR0, COM01);
  cbi(TCCR0, COM00);


  cbi(TCCR0, CS02);
  sbi(TCCR0, CS01);
  sbi(TCCR0, CS00);

  sbi(TIMSK, TOIE0);

  sei();
  while(true);
  return 0;
}

