#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "global.h"
#include "delay.h"
#include "uart.h"
#include "key.h"
#include "adc.h"

volatile unsigned char rx_flag=false;
volatile unsigned char recv_datd=0;

volatile unsigned int read_adc=0;
volatile float           temp_volt=0;
volatile unsigned char adc_flag=false;

char read_adc_string[16]={0,0,0,0,};
char temp_volt_string[16]={0,0,0,0,};

ISR(ADC_vect){
  read_adc=ADCL;
  read_adc+=(ADCH<<8);
  adc_flag=true;
}

ISR(USART0_RX_vect){
  rx_flag=true;
  recv_datd=UDR0;
}


int main(void) {
  uart0_init(BAUD_57600);
  adc_init(ADC_CH_0);
  delay_ms(10);

  while(true){
    if(adc_flag==true){
      adc_flag=false;

      temp_volt=read_adc * (5.0/1023.0);

      sprintf(read_adc_string, "%4d", read_adc);
      sprintf(temp_volt_string, "%6.2f", temp_volt);

      tx_string("Angle:");
      tx_string(temp_volt_string);
      tx_string(" (V) -> ADC:");
      tx_string(read_adc_string);
      tx_string("/n");
    }
    delay_ms(200);
  }
}

