/**
* @file   : clcd.h
* @brief  : clcd 
* @author : carroty / carroty.com : jung sang hoon / company
* @date   : 2012.04.09
* @remarks
* -  1
* -  2
* @par [̷]
* - 2012.xx.xx /  / v1.0 /  
* - 2012.xx.xx /  / v1.1 /  
*/
#ifndef __CLCD_H__
#define __CLCD_H__

/*************************************************************************************
DATA_BUS // 4Ʈ  2008 4 21 940 Ȯ 
**************************************************************************************/
#include <avr/io.h>

/********************************/
// CLCD Pin Desciption
/********************************/
//  ޶  ̺κи ϸ ˴ϴ.  쿡  ٲپ κ  ֽϴ.
// 1. Control Bus

#include "wh0802a-yyh-jt.h"

#define BIT4_MODE           10  //   ƹ ǹ̾.  ϱ    
#define BIT8_MODE           20

//#define CLCD_CONTROL_DDR  DDRD
//#define CLCD_RS           0
//#define CLCD_RW           1
//#define CLCD_EN           2

//#define CLCD_DATA_DDR     DDRC
//#define CLCD_DATA_PORT    PORTC

#define CLCD_PORT           WH0802A_CLCD_PORT
#define CLCD_DDR            WH0802A_CLCD_DDR

#define RS                  WH0802A_RS
#define RW                  WH0802A_RW
#define EN                  WH0802A_EN

// Busy Check Pin
#define BUSY_PIN            0 
#define DATA_BUS_BUSY       1

#define MAX_ROW             WH0802A_MAX_ROW 
#define MAX_COL             WH0802A_MAX_COL 

#define DEFAULT_WAIT_TIME   10       //  clcd busy check    󸶸 ٸ ϴ ,  ms Դϴ 
                                     // Ȥ ߱ Ƿ ǰ busy check    
/*
00071 // HD44780 LCD controller command set (do not modify these)
00072 // writing:
00073 #define LCD_CLR             0      // DB0: clear display
00074 #define LCD_HOME            1      // DB1: return to home position
00075 #define LCD_ENTRY_MODE      2      // DB2: set entry mode
00076 #define LCD_ENTRY_INC       1      // DB1: increment
00077 #define LCD_ENTRY_SHIFT     0      // DB2: shift
00078 #define LCD_ON_CTRL         3      // DB3: turn lcd/cursor on
00079 #define LCD_ON_DISPLAY      2      // DB2: turn display on
00080 #define LCD_ON_CURSOR       1      // DB1: turn cursor on
00081 #define LCD_ON_BLINK        0      // DB0: blinking cursor
00082 #define LCD_MOVE            4      // DB4: move cursor/display
00083 #define LCD_MOVE_DISP       3      // DB3: move display (0-> move cursor)
00084 #define LCD_MOVE_RIGHT      2      // DB2: move right (0-> left)
00085 #define LCD_FUNCTION        5      // DB5: function set
00086 #define LCD_FUNCTION_8BIT   4      // DB4: set 8BIT mode (0->4BIT mode)
00087 #define LCD_FUNCTION_2LINES 3      // DB3: two lines (0->one line)
00088 #define LCD_FUNCTION_10DOTS 2      // DB2: 5x10 font (0->5x7 font)
00089 #define LCD_CGRAM           6      // DB6: set CG RAM address
00090 #define LCD_DDRAM           7      // DB7: set DD RAM address
00091 // reading:
00092 #define LCD_BUSY            7      // DB7: LCD is busy
*/

/********************************/
// CLCD Commands
/********************************/
// HD44780 LCD controller command set
// 1. Clear Display
#define CMD_CLEAR_DISPLAY                0x01

// 2. Return HOME
#define CMD_RETURN_HOME                  0x02

// 3. Entry Mode Set
#define CMD_ENTRY_MODE_SET_OPTION1       0x04 // cursor [left],  display shift [none]
#define CMD_ENTRY_MODE_SET_OPTION2       0x05 // cursor [left],  display shift []
#define CMD_ENTRY_MODE_SET_OPTION3       0x06 // cursor [right], display shift [none] // *** Used
#define CMD_ENTRY_MODE_SET_OPTION4       0x07 // cursor [right], display shift []

// 4. Display On/Off
#define CMD_DISPLAY_OPTION1              0x08 // Display [Off], Cursor [Off], Cursor Blink [Off]
#define CMD_DISPLAY_OPTION2              0x09 // Display [Off], Cursor [Off], Cursor Blink [On]
#define CMD_DISPLAY_OPTION3              0x0A // Display [Off], Cursor [On],  Cursor Blink [Off]
#define CMD_DISPLAY_OPTION4              0x0B // Display [Off], Cursor [On],  Cursor Blink [On]
#define CMD_DISPLAY_OPTION5              0x0C // Display [On],  Cursor [Off], Cursor Blink [Off]
#define CMD_DISPLAY_OPTION6              0x0D // Display [On],  Cursor [Off], Cursor Blink [On]
#define CMD_DISPLAY_OPTION7              0x0E // Display [On],  Cursor [On],  Cursor Blink [Off]
#define CMD_DISPLAY_OPTION8              0x0F // Display [On],  Cursor [On],  Cursor Blink [On] // *** Used

// 5. Cursor or Display Shift
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION1 0x10 // [Cursor] Select,  Cursor Shift  [Left]
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION2 0x14 // [Cursor] Select,  Cursor Shift  [Right]
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION3 0x18 // [Display] Select, Display Shift [Left]
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION4 0x1C // [Display] Select, Display Shift [Right]

// 6. Function Set
#define CMD_FUNCTION_SET_OPTION1         0x20 // [4] bit mode, [1] line, [5x8] Font
#define CMD_FUNCTION_SET_OPTION2         0x24 // [4] bit mode, [1] line, [5x11] Font
#define CMD_FUNCTION_SET_OPTION3         0x28 // [4] bit mode, [2] line, [5x8] Font // *** Used
#define CMD_FUNCTION_SET_OPTION4         0x2C // [4] bit mode, [2] line, [5x11] Font
#define CMD_FUNCTION_SET_OPTION5         0x30 // [8] bit mode, [1] line, [5x8] Font
#define CMD_FUNCTION_SET_OPTION6         0x3C // [8] bit mode, [1] line, [5x11] Font
#define CMD_FUNCTION_SET_OPTION7         0x34 // [8] bit mode, [2] line, [5x8] Font
#define CMD_FUNCTION_SET_OPTION8         0x38 // [8] bit mode, [2] line, [5x11] Font

#define LINE1                            0x00 // first  line DDRAM address 0x80=  0x80 + 0x00
#define LINE2                            0x40 // second line DDRAM address 0xC0=  0x80 + 0x40

void clcd_port_init();
void clcd_init();
void clcd_busy_check();
void clcd_home();
void clcd_clear();
void clcd_position(unsigned char x, unsigned char y);
void clcd_command(unsigned char cmd);
void clcd_string(unsigned char cmd, char *string);

void clcd_data(unsigned char data);
void clcd_position(unsigned char x, unsigned char y);
void clcd_char(unsigned char ch);

#endif
