#include <avr/io.h>

#include "global.h"
#include "delay.h"
#include "clcd.h"

#include "wh0802a-yyh-jt.h"

//#define  LINE1 0x00
//#define  LINE2 0x40

//#define DATA_BUS_BUSY       1
//#define BUSY_PIN            0 

//#define sbi(reg,bit)    reg |= (1<<(bit))			
//#define cbi(reg,bit)    reg &= ~(1<<(bit))

void wh0802a_port_init(void) {
  //DDRA =    0xFF;   // Ʈ  Ʈ  
  WH0802A_CLCD_DDR= 0xFF;
}


void wh0802a_init() {
  wh0802a_port_init();
  delay_ms(500); 
  // Power On : Wait for more than 40ms after VDD rises to 4.5V
  delay_ms(48); // 48ms = 40 + 40*20%
  // 8ms CLCD ʱ ð Ȯ  Ϻη  

  wh0802a_command(0x30); // Function set
  delay_us(50); // Wait for more than 39us

  wh0802a_command(0x20); // Function Set
  wh0802a_command(0x00);
  delay_us(50);

  wh0802a_command(0x00); // Display ON/OFF control
  wh0802a_command(0x80); 
  delay_us(50);

  wh0802a_command(0x00); // Display Clear
  wh0802a_command(0x10);
  delay_ms(4); // Wait for more than 1.53ms

  wh0802a_command(0x00); // Entry Mode Set
  wh0802a_command(0x40);

  // Initialization ends
  delay_ms(500); 
}

/**
  \brief clcd  busy ƴ ϴ Լ
  \param void
  \return void
  \remark PORTA Ʈ Ͽ 1(=busy) 0(=no busy) Ѵ.
  ͸    ٻ ƴ üũؾ ϱ ̴.
  Ư LCD busy ȣ  ȳִ 찡 ֱ  50ms(? ³)  ٻڴٰ Ѵٸ
  ׳ busy  .
*/
void wh0802a_busy_check(void) {
  
  unsigned char busy_flag=    0;
  unsigned int  busy_time=    0;  

  do { 
    cbi(WH0802A_CLCD_PORT, RS);  // RS= 0
	sbi(WH0802A_CLCD_PORT, RW);  // RW= 1
	sbi(WH0802A_CLCD_PORT, EN);  // EN= 1

    busy_flag= DATA_BUS_BUSY;
	sbi(WH0802A_CLCD_PORT, EN);  // EN= 1
	cbi(WH0802A_CLCD_PORT, EN);  // EN= 0

    busy_time++;
  } while((busy_flag & BUSY_PIN) && (busy_time < 500));     // busy=1    
  
  // busy=0 ,  
  //CONTROL_BUS_DDR |=    0x0F;   // Ʈ 
  //DATA_BUS_DDR |=       0xFF;   //  
  //cbi(CONTROL_BUS, EN);               // EN= 0
}
/*
void clcd_busy_check(void) {
  tmp_delay_ms(3);
}
*/


/**
  \brief clcd ɾ(command)  Լ
  \param unsigned char
  \return void
  \remark busy üũ ѹϰ,  Ϻ, Ϻ ι  ͸ Ѵ.
  4Ʈ Ǿϱ ̷ 8Ʈ Ǿ  ѹ濡  .
*/
void wh0802a_command(unsigned char cmd) {
   WH0802A_CLCD_PORT = (cmd & 0xF0);            // RW=0, RS=0
   cbi(WH0802A_CLCD_PORT, RS);                  // RS = 0 // command
   cbi(WH0802A_CLCD_PORT, RW);
   sbi(WH0802A_CLCD_PORT, EN);                  // EN = 1
   asm volatile("NOP");
   asm volatile("NOP");
   cbi(WH0802A_CLCD_PORT, EN);                  // EN = 0
delay_us(50);
   WH0802A_CLCD_PORT = (cmd & 0x0F)<<4;            // RW=0, RS=0
   cbi(WH0802A_CLCD_PORT, RS);                  // RS = 0 // command
   cbi(WH0802A_CLCD_PORT, RW);
   sbi(WH0802A_CLCD_PORT, EN);                  // EN = 1
   asm volatile("NOP");
   asm volatile("NOP");
   cbi(WH0802A_CLCD_PORT, EN);                  // EN = 0
   delay_us(50);  // qqq 28 ̸ Ǹ  234568 ̷ ϰ 
} 
/**
  \brief clcd (data)  Լ
  \param unsigned char
  \return void
  \remark busy üũ ѹϰ,  Ϻ, Ϻ ι  ͸ Ѵ.
   ɾ  Լϰ RS    Ȱ.
*/
void wh0802a_data(unsigned char data) {
   WH0802A_CLCD_PORT = (data & 0xF0);            // RW=0, RS=0
   sbi(WH0802A_CLCD_PORT, RS);                  // RS = 0 // command
   cbi(WH0802A_CLCD_PORT, RW);
   sbi(WH0802A_CLCD_PORT, EN);                  // EN = 1
   asm volatile("NOP ");
   asm volatile("NOP ");
   cbi(WH0802A_CLCD_PORT, EN);                  // EN = 0
delay_us(50);
   WH0802A_CLCD_PORT = (data & 0x0F)<<4;            // RW=0, RS=0
   sbi(WH0802A_CLCD_PORT, RS);                  // RS = 0 // command
   cbi(WH0802A_CLCD_PORT, RW);
   sbi(WH0802A_CLCD_PORT, EN);                  // EN = 1
   asm volatile("NOP ");
   asm volatile("NOP ");
   cbi(WH0802A_CLCD_PORT, EN);                  // EN = 0
   
   delay_us(50);  // qqq 28 ̸ Ǹ  234568 ̷ ϰ 
}

/**
  \brief clcd ũ(scroll)  ϴ Լ
  \param unsigned char
  \return void
  \remark ,  Ű° .. . 
*/
void scroll(unsigned char direction) {
  if(direction==1) wh0802a_command(0x1C);
  else wh0802a_command(0x18);
}

/**
  \brief clcd Ŀ ġ ѹ濡 ̵Ű Լ
  \param unsigned char x, unsigned char y
  \return void
  \remark   ϸ   ؿ.
*/
unsigned char wh0802a_position(unsigned char x, unsigned char y) {
  unsigned char location=0; 
  if(y>0x01) { y= 0x01; }
  if(x>0x0F) { x= 0x0f; }
  if(y==0) { location = x + LINE1; } //1࿡ ǥ 
  else { location = x + LINE2; } //2࿡ ǥ
  return location;
}


/**
  \brief clcd ڿ(char*)   Լ
  \param unsigned char
  \return void
  \remark cmd ֺ(?)  ... ڿ  Լ
  null    Լ  ȣմϴ.
*/
void wh0802a_string(unsigned char cmd, char *string) {
  wh0802a_command(cmd);
  while(*string !='\0') {
    wh0802a_data(*string);
	string++;	
  }
}



