/**
* @file   : clcd.h
* @brief  : clcd 
* @author : carroty / carroty.com : jung sang hoon / company
* @date   : 2012.04.09
* @remarks
* -  1
* -  2
* @par [̷]
* - 2012.xx.xx /  / v1.0 /  
* - 2012.xx.xx /  / v1.1 /  
*/
#ifndef __WH0802A_YYH_JT_H__
#define __WH0802A_YYH_JT_H__

/*************************************************************************************
DATA_BUS // 4Ʈ  2008 4 21 940 Ȯ 
**************************************************************************************/


/********************************/
// CLCD Pin Desciption
/********************************/
//  ޶  ̺κи ϸ ˴ϴ.  쿡  ٲپ κ  ֽϴ.
// 1. Control Bus

/*
MCU <-> WH0802A-YYH-JT
PIN  1  : GND
PIN  2  : VCC (5V)
PIN  3  : V0
PIN  4  : RS    PA0   Used
PIN  5  : R/W   PA1   Used
PIN  6  : EN    PA2   Used
PIN  7  : DB0   N.C.
PIN  8  : DB1   N.C.
PIN  9  : DB2   N.C.
PIN 10  : DB3   N.C.
PIN 11  : DB4   PA4   Used 
PIN 12  : DB5   PA5   Used 
PIN 13  : DB6   PA6   Used 
PIN 14  : DB7   PA7   Used 
*/

//#define CLCD_CONTROL_DDR          DDRD
//#define CLCD_RS                   0
//#define CLCD_RW                   1
//#define CLCD_EN                   2

//#define CLCD_DATA_DDR             DDRC
//#define CLCD_DATA_PORT            PORTC

#define WH0802A_CLCD_PORT           PORTA
#define WH0802A_CLCD_DDR            DDRA

#define WH0802A_RS                  0 
#define WH0802A_RW                  1 
#define WH0802A_EN                  2 

#define WH0802A_MAX_ROW             2
#define WH0802A_MAX_COL             8

#define WH0802A_LINE1               0x80 // first  line DDRAM address 0x80=  0x80 + 0x00
#define WH0802A_LINE2               0xC0 // second line DDRAM address 0xC0=  0x80 + 0x40

/********************************/
// CLCD Commands
/********************************/
// HD44780 LCD controller command set
// 1. Clear Display
#define CMD_CLEAR_DISPLAY                0x01

// 2. Return HOME
#define CMD_RETURN_HOME                  0x02

// 3. Entry Mode Set
#define CMD_ENTRY_MODE_SET_OPTION1       0x04 // cursor [left],  display shift [none]
#define CMD_ENTRY_MODE_SET_OPTION2       0x05 // cursor [left],  display shift []
#define CMD_ENTRY_MODE_SET_OPTION3       0x06 // cursor [right], display shift [none] // *** Used
#define CMD_ENTRY_MODE_SET_OPTION4       0x07 // cursor [right], display shift []

// 4. Display On/Off
#define CMD_DISPLAY_OPTION1              0x08 // Display [Off], Cursor [Off], Cursor Blink [Off]
#define CMD_DISPLAY_OPTION2              0x09 // Display [Off], Cursor [Off], Cursor Blink [On]
#define CMD_DISPLAY_OPTION3              0x0A // Display [Off], Cursor [On],  Cursor Blink [Off]
#define CMD_DISPLAY_OPTION4              0x0B // Display [Off], Cursor [On],  Cursor Blink [On]
#define CMD_DISPLAY_OPTION5              0x0C // Display [On],  Cursor [Off], Cursor Blink [Off]
#define CMD_DISPLAY_OPTION6              0x0D // Display [On],  Cursor [Off], Cursor Blink [On]
#define CMD_DISPLAY_OPTION7              0x0E // Display [On],  Cursor [On],  Cursor Blink [Off]
#define CMD_DISPLAY_OPTION8              0x0F // Display [On],  Cursor [On],  Cursor Blink [On] // *** Used

// 5. Cursor or Display Shift
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION1 0x10 // [Cursor] Select,  Cursor Shift  [Left]
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION2 0x14 // [Cursor] Select,  Cursor Shift  [Right]
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION3 0x18 // [Display] Select, Display Shift [Left]
#define CMD_CURSOR_DISPLAY_SHIFT_OPTION4 0x1C // [Display] Select, Display Shift [Right]

// 6. Function Set
#define CMD_FUNCTION_SET_OPTION1         0x20 // [4] bit mode, [1] line, [5x8] Font
#define CMD_FUNCTION_SET_OPTION2         0x24 // [4] bit mode, [1] line, [5x11] Font
#define CMD_FUNCTION_SET_OPTION3         0x28 // [4] bit mode, [2] line, [5x8] Font // *** Used
#define CMD_FUNCTION_SET_OPTION4         0x2C // [4] bit mode, [2] line, [5x11] Font
#define CMD_FUNCTION_SET_OPTION5         0x30 // [8] bit mode, [1] line, [5x8] Font
#define CMD_FUNCTION_SET_OPTION6         0x3C // [8] bit mode, [1] line, [5x11] Font
#define CMD_FUNCTION_SET_OPTION7         0x34 // [8] bit mode, [2] line, [5x8] Font
#define CMD_FUNCTION_SET_OPTION8         0x38 // [8] bit mode, [2] line, [5x11] Font

// function prototype
void wh0802a_port_init(void);
void wh0802a_init(void);
void wh0802a_busy_check(void);
void wh0802a_command(unsigned char cmd);
void wh0802a_data(unsigned char data);
void scroll(unsigned char direction);
unsigned char wh0802a_position(unsigned char x, unsigned char y);
void wh0802a_string(unsigned char cmd, char *string);

#endif
